/*  testLZO.c--  The small test for picoLZO.h--

    Usage: testLZO filename
*/

#define MEMSIZE 4096*30

#include "../lib/io.h"
#include "../lib/file_system.h"
#include "../lib/strings.h"
#include "picoLZO.h"

char wrkmem[65536];

void main()
{
	char savepath[4096];
	dword pBuffer1,pBuffer2,pBuffer3;
	int size_read, size_lzo, size_reconstructed;

	if (!param[0]) {
		notify("'testLZO\nUse this app with params:\ntestLZO.kex [infile]' -tE");
		ExitProcess();
	}
	io.read(#param);
	size_read = io.FILES_SIZE;

	if (!size_read) {
		notify("'testLZO\nIn file not found!' -tE");
		ExitProcess();
	}

	pBuffer1 = io.buffer_data;
	pBuffer2 = malloc(size_read + 10);
	pBuffer3 = malloc(size_read + 10);

	picolzo_compress(pBuffer1, size_read, pBuffer2, #size_lzo, #wrkmem);
	picolzo_decompress(pBuffer2, size_lzo, pBuffer3, #size_reconstructed);
	
	debugval("Original size", size_read);
	debugval("Compressed size", size_lzo);
	debugval("Decompressed size", size_reconstructed);

	param[strrchr(#param, '/')-1]=NULL; //no "/" in the end
	SetCurDir(#param);
	
	sprintf(#savepath, "%s/out_compressed", #param);
	io.file.write(size_lzo, pBuffer2, #savepath);
	sprintf(#savepath, "%s/out_reconstructed", #param);
	io.file.write(size_reconstructed, pBuffer3, #savepath);

	notify("'testLZO\n\x60out_compressed\x60 and \x60out_reconstructed\x60\nare succesfully created' -tO");

	free(pBuffer1);
	free(pBuffer2);
	free(pBuffer3);
	ExitProcess();
}
